//+------------------------------------------------------------------+
//|     Expiration Data                                              |
//+------------------------------------------------------------------+
string exp_Message_account = "Trial Version of EA is Not Working on your Account Number, Please Contact me at xxx@xxx.Com";
int exp_account_number = 0; // 0 mean working on any account
///
string exp_Message_date = "Trial Version of EA is Expired, Please Contact me at xxx@xxx.Com";
int exp_year = 2032; // make it long like 2050 to disable it
int exp_month = 04;
int exp_day = 30;
//+------------------------------------------------------------------+
//|                                           open_trade_with_MM.mq4 |
//|                                     Copyright 2019, ProTraderLab |
//|                                      http://www.protraderlab.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, DanSan Trading Softwares"
#property link      "https://www.upwork.com/o/profiles/users/_~01c67e227993bf611e/"
#property description "mail : mohamedissa840@yahoo.com"
#property description "phone: +201063746674"
#property version   "1.00"
#property strict
#property show_inputs
//#include <StarterEA_FunctionsFreeC.mqh>

input string n0 = " ============ Operation ============ ";//------
enum TradeOper
  {
   BUY = OP_BUY,
   SELL = OP_SELL,
  };
extern TradeOper operation = BUY;
extern double PendingPrice = 0.00;
input string n1 = " ============ StopLoss ============ ";//------
//////////////
enum mode_stoploss {SL_ByBar,SL_ByFixed};
input mode_stoploss Mode_StopLoss = SL_ByBar;
input int    SL_y_Bar = 3;//SL previous Y candle's high/low
input double SL_X_Pips = 15;//SL goes x pips Above/Below
extern int   Fixed_SL = 230;
/////////////////////
input string n2 = " ============ Lot ============ ";//------

enum mode_lot {LOT_ByMoney,LOT_ByPercentage,LOT_ByFixed};
input mode_lot Mode_Lot = LOT_ByMoney;
extern double Fixed_Lot = .01;
extern double risk_in_money = 10;
extern double risk_in_percetage = 2;
////////////////////////
input string n3 = " ============ TakeProfit ============ ";//------

enum mode_takeprofit {TP_ByRiskRewardRatio,TP_ByFixed};
input mode_takeprofit Mode_TP = TP_ByRiskRewardRatio;
input int RiskRewardRatio = 10;
extern int Fixed_TP = 2000;

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
///Check For Date Expired
   if(!GetAccess(exp_Message_account, exp_Message_date, exp_account_number, exp_year, exp_month, exp_day))
     {
      ExpertRemove();
      return;
     }
/////////
//---
   double lot, risk, sl, tp;
   getLotSLTP(operation,lot, risk, sl, tp);
   int res;
   double price;
   if(lot > 0 && sl >=0 && tp >= 0)
      if(MathAbs(PendingPrice) < Point())
        {
         price = (operation == BUY? Ask : Bid);
         sl = price + Point()*sl*(operation == BUY? -1: 1);
         tp = price + Point()*tp*(operation == BUY? 1: -1);
         Print(price, " = ", sl, " = ", tp);
         res = OrderSend(Symbol(), operation, lot, price, 3, sl, tp, NULL, 0, 0, (operation==BUY? clrBlue : clrRed));
        }
      else
         if(PendingPrice > Point())
           {
            int oper =-1;
            if(operation == BUY)
               if(PendingPrice > Bid)
                  oper = OP_BUYSTOP;
               else
                  oper = OP_BUYLIMIT;
            else
               if(operation == SELL)
                  if(PendingPrice > Bid)
                     oper = OP_SELLLIMIT;
                  else
                     oper = OP_SELLSTOP;
            price = PendingPrice;
            sl = price + Point()*sl*(operation == BUY? -1: 1);
            tp = price + Point()*tp*(operation == BUY? 1: -1);
            res = OrderSend(Symbol(), oper, lot, PendingPrice, 3, sl, tp, NULL, 0, 0, (operation==BUY? clrBlue : clrRed));
           }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void getLotSLTP(int ty,double &lot, double &risk, double &sl, double &tp)
  {
/////////////
   string symbol = Symbol();
   int digits = int(MarketInfo(symbol, MODE_DIGITS));
   double point = MarketInfo(symbol, MODE_POINT);
   double lot_val = MarketInfo(symbol,MODE_TICKVALUE);//price of 1 point for 1.00 lot
   double lot_step = MarketInfo(symbol, MODE_LOTSTEP);
   lot = 0;
   if(Mode_Lot==LOT_ByFixed)
      lot = Fixed_Lot;
   risk = Get_riskMoney();
   sl = GetSL_Points(ty);
   if(MathAbs(risk) < point && risk>0)
     {
      Print("Risk not set. Using parameters.");
      return;
     }
   double equity = AccountEquity();
   if(MathAbs(lot) < point && sl > 0 && risk > 0)
     {
      lot = risk / (sl * lot_val);
      if(lot*lot_val*sl > risk)
         lot -= lot_step;
     }
   if(MathAbs(sl) < point && lot > 0 && risk > 0)
     {
      sl = risk / (lot * lot_val);
      if(lot*lot_val*sl > risk)
         sl -= 1;
     }
   tp = GetTP_Points(sl);
   lot = NormalizeDouble(lot, 2);
   if(lot < MarketInfo(symbol, MODE_MINLOT))
      lot = MarketInfo(symbol, MODE_MINLOT);
   if(lot > MarketInfo(symbol, MODE_MAXLOT))
      lot = MarketInfo(symbol, MODE_MAXLOT);
  }
//+------------------------------------------------------------------+
double GetSL_Points(int ty)
  {
   double res = Fixed_SL;
   if(Mode_StopLoss == SL_ByBar)
     {
      if(ty==OP_BUY)
        {
         res = Low[iLowest(_Symbol,0,MODE_LOW,SL_y_Bar,1)];
         res = res-(SL_X_Pips*_Point);
         res = MathAbs(Ask - res)/_Point;
        }
      if(ty==OP_SELL)
        {
         res = High[iHighest(_Symbol,0,MODE_HIGH,SL_y_Bar,1)];
         res =res+(SL_X_Pips*_Point);
         res = MathAbs(Bid - res)/_Point;
        }
     }
   return res;
  }
//+------------------------------------------------------------------+
double GetTP_Points(double sl_points)
  {
   double res = Fixed_TP;
   if(Mode_TP==TP_ByRiskRewardRatio)
     {
      res = sl_points * RiskRewardRatio;
     }
   return res;
  }
//+------------------------------------------------------------------+
double Get_riskMoney()
  {
   double res = 0;
   if(Mode_Lot==LOT_ByMoney)
      res = risk_in_money;
   if(Mode_Lot==LOT_ByPercentage)
      res = (AccountEquity()/100)*risk_in_percetage;
   return res;
  }
//+------------------------------------------------------------------+
bool GetAccess(string message_account, string message_date, int accountnumber = 0, int end_year = 2023, int end_month = 2023, int end_day = 2023)
  {
   if(accountnumber != 0 && AccountNumber() != accountnumber)
     {
      Alert(message_account);
      Comment(message_account);
      ExpertRemove();
      return false;
     }
   datetime endtime = StringToTime(StringFormat("%s.%s.%s 00:00", (string)end_year, (string)end_month, (string)end_day));
   if(TimeCurrent() >= endtime)
     {
      Alert(message_date);
      Comment(message_date);
      ExpertRemove();
      return false;
     }
   return true;
  }
//+------------------------------------------------------------------+
